(* NOT CURRENTLY PART OF THE BENCHMARK *)


let unsome = function
   | None -> assert false
   | Some x -> x

(*-----------------------------------------------------------------------------*)

module Chunk = FixedCapaStack

(** Aliases *)

type 'a chunk = 'a Chunk.t 


(*-----------------------------------------------------------------------------*)

(** TODO: update

    Representation of a bootstrapped stack:
    -- front-outer buffer: where top elements are pushed 
    -- front-inner buffer: elements after front-outer
    -- middle: an option on a bootstrapped stack of chunks, 
       storing deeper elements in the stack.

    The front-inner buffer is always either empty or full.
    The structure is empty iff the front-outer buffer is empty.
    If middle is not None, then it must store at least one chunk. *)

and 'a t = { 
  mutable outer_size : int;
  mutable outer_data : 'a array;
  mutable inner_size : int;
  mutable inner_data : 'a array;
  mutable middle : (('a chunk) t) option; 
  capacity : int;
  default : 'a; }


(*-----------------------------------------------------------------------------*)

(** Creation *)

let create capacity d = 
  { outer_size = 0;
    outer_data = [|d;d|]; 
    inner_size = 0;
    inner_data = [||];
    middle = None;
    capacity = capacity;
    default = d; }

(** Emptiness test *)    
  
let is_empty s = 
  (s.outer_size = 0)

(** Push front *)

let rec push : 'a. 'a -> 'a t -> unit = fun x s ->
   let lo = Array.length s.outer_data in
   if s.outer_size = s.capacity then begin
      let di = s.inner_data in
      let ni = s.inner_size in
      s.inner_size <- s.outer_size;
      s.inner_data <- s.outer_data;
      s.outer_size <- 0;
      if ni = 0 then begin
         if Array.length di = 0 then begin
            s.outer_data <- Array.make s.capacity s.default;
         end else begin
            s.outer_data <- di;
         end
      end else begin
         s.outer_data <- Array.make s.capacity s.default;
         if s.middle = None then begin
            let cd = Chunk.create 0 s.default in
            let m = create s.capacity cd in
            s.middle <- Some m;
         end;
         let ci = Chunk.build ni di s.default in
         push ci (unsome s.middle);
      end
   end else if s.outer_size = lo then begin
      let d = s.outer_data in
      let d2 = Array.make (2 * lo) s.default in
      Array.blit d 0 d2 0 lo;
      s.outer_data <- d2;
   end;
   s.outer_data.(s.outer_size) <- x;
   s.outer_size <- s.outer_size + 1

(** Pop front *)

let rec pop : 'a. 'a t -> 'a = fun s -> 
   let i = s.outer_size - 1 in
   s.outer_size <- i;
   let x = s.outer_data.(i) in
   if s.outer_size = 0 then begin
      if s.inner_size <> 0 then begin
         let d = s.outer_data in
         s.outer_size <- s.inner_size;
         s.outer_data <- s.inner_data;
         s.inner_size <- 0;
         s.inner_data <- d;
      end else begin
         match s.middle with
         | None -> ()  (* structure is now empty *)
         | Some m ->
            let c = pop m in
            s.outer_size <- s.capacity;
            s.outer_data <- Chunk.data c;
            if is_empty m then begin
               s.middle <- None;
            end
      end;
   end;
   x

(** Top

let top : 'a. 'a t -> 'a = fun s -> 
   let co = s.front_outer in
   assert (not (Chunk.is_empty co));
   let x = Chunk.pop co in
   x
 *)

(*-----------------------------------------------------------------------------*)

