

(********************************************************************)
(** Wrapper building a defensive stack from a stack *)

module Make (M : StackSig.S) : StackSig.S =
struct

  type 'a t = 'a M.t

  let create = M.create

  let clear = M.clear

  let length = M.length

  let is_empty = M.is_empty

  let push = M.push

  let pop s = 
    assert (Vocal.assume || not (is_empty s));
    M.pop s

  let top s = 
    assert (Vocal.assume || not (is_empty s));
    M.top s

  let pop_exn = pop_exn

  let top_exn = top_exn

  let pop_opt = pop_opt

  let top_opt = top_opt

  let iter = M.iter

  let iteri = M.iteri

end

