
(** A list-based implementation of mutable stacks,
    where push and pop are O(1) and length is O(n). *)


type 'a t = ('a list) ref

let create () = 
  ref []

let clear s = 
  s := []

let is_empty s = 
  !s = []

let length s = 
  List.length !s

let push x s = 
  s := x :: !s

let pop s =
  match !s with
  | hd::tl -> s := tl; hd
  | [] -> assert false

let top s =
  match !s with
  | hd::tl -> hd
  | [] -> assert false

let iteri f s = 
   List.iteri f !s
