
(********************************************************************)
(** Wrapper building a exception-defensive stack from a stack *)

module Make (M : StackImpl.S) : StackSig.S =
struct

  type 'a t = 'a M.t

  exception Empty

  let create = M.create

  let clear = M.clear

  let length = M.length

  let is_empty = M.is_empty

  let push = M.push
   
  let pop = M.pop

  let top = M.top

  let pop_exn s = 
    if is_empty s then raise Empty;
    M.pop s

  let top_exn s = 
    if is_empty s then raise Empty;
    M.top s

  let pop_opt s = 
    if is_empty s then None else Some (M.pop s)

  let top_opt s = 
    if is_empty s then raise Empty else Some (M.top s)

  let iteri_left = M.iteri_left

  let iter_left f l = 
    M.iteri_left (fun i v -> f v) l

  let iter = iter_left 

end

