
(** A vector-based implementation of mutable stacks,
    where push and pop are amortized O(1), 
    and length is O(1). *)


let create = Vector.create

let clear = Vector.clear

let is_empty = Vector.is_empty

let length = Vector.length

let push x s = 
  let n = length s in
  Vector.incr_size s;
  Vector.set n x

let pop s =
  let n = length s in
  let x = Vector.get s (n-1) in
  Vector.decr_size s;
  x

let top s =
  let n = length s in
  Vector.get s (n-1)

let iter = Vector.iter
