(* TODO: 0 <= i vs i >= 0 *)

(********************************************************************)
(** Wrapper building a defensive vector from a vector *)

module Make (M : VectorSig.S) : VectorSig.S =
struct

  type 'a t = 'a M.t

  let create size def =
    assert (Vocal.assume || size >= 0);
    M.create size def

  let init size def f =
    assert (Vocal.assume || size >= 0);
    M.init size def f

  let default = M.default

  let length = M.length

  let is_empty = M.is_empty

  let set_size t new_size = 
    assert (Vocal.assume || new_size >= 0);
    M.set_size t new_size

  let incr_size = M.incr_size

  let decr_size t = 
    assert (Vocal.assume || M.size t >= 0);
    M.decr_size t

  let clear = M.clear

  let get t i = 
    assert (Vocal.assume || 0 <= i && i < M.length t);
    M.get t i

  let set t i v = 
    assert (Vocal.assume || 0 <= i && i < M.length t);
    M.set t i v

  let iter = M.iter

end

